add err-print, slight output improvement, docs
[errhandle.git] / README
diff --git a/README b/README
index 745858606c226bf23bae0c692890c2d92e365517..b8e85f293991ede0c82367c9c54a2b36a4a0c9d9 100644 (file)
--- a/README
+++ b/README
@@ -1,19 +1,22 @@
-Functions to deal with errors in bash.
+Bash stack trace and error handling functions
 
-bash-trace: print stack trace (best bash stack trace ever).
-errcatch: on error, do stack trace ane exit
-errallow: undo errcatch
-errexit: exit and print stack trace
+Usually, just copy the err file and source it. Then on any non-zero
+return code outside of a conditional, the program will exit and print a
+stack trace.
 
-the err* functions depend on bash-trace.
+The err file has some functions which you may want to call manually for
+different or additional error handling. See the comments at the start of
+each one.
 
-
-For scripts which don't or hardly contains functions, this is usually sufficient:
+For scripts where functions are not used, you can optionally use a more
+minimal approach:
 set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
+In the above line, cleanup commands or functions can be appended to the
+ERR trap after a semicolon within the single quotes.
 
-Related: see my bash script template repo.
+Related: see my bash script template repo, at https://iankelling.org/git.
 
-Patches, bugs, and any feedback is very welcome via email to
-Ian Kelling <ian@iankelling.org>.
+Please email me if you have a patches, bugs, feedback, or republish this
+somewhere else: Ian Kelling <ian@iankelling.org>.